(define-module (type timezone)
    :use-module (alterator woo)
    :export (type)) 

(define *timezone-regex-str* "^[A-Z][A-Za-z-]+(/[A-Z][A-Za-z_-]+)*$")

(define *timezone-regex* (make-regexp *timezone-regex-str* regexp/extended))

(define (type v _)
  (or (and (string? v) (string-null? v))
      (and (string? v) (regexp-exec *timezone-regex* v))
      (type-error (format #f
                          (_ "Wrong timezone: ~s. Timezone like Europe/Moscow, etc. is allowed")
                          v))))
