(define-module (ui datetime system ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator woo)
	       :use-module (alterator effect)
	       :export (init))

(define (ui-timezone)
  (form-replace "/datetime/system/timezone"))

(define (clocksource-show)
  (form-update-visibility "clocksource_show"
    (and 
      (equal? "1" (form-cookie "expert_mode"))
      (woo-get-option (woo-read-first "/datetime-system") 'clocksource_show)
    )
  )
)

(define (ui-timeedit)
  (catch/message
    (lambda()
      (form-update-value-list
	'("time")
	(woo-read-first "/datetime-system")))))

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/datetime-system"
	     'language (form-value "language")
	     (form-value-list))
      (ui-read))))

(define (ui-read)
  (catch/message
	(lambda()
	  (let ((cmd (woo-read-first "/datetime-system" 'language (form-value "language"))))
		(form-update-value-list '("date" "time" "ntp_status" "ntp_pool" "ntp_accept" "utc" "timezone")
								cmd)
		(form-update-activity "ntp_status" (woo-get-option cmd 'ntp_installed)))
		(form-update-enum "clocksources" (woo-list "/datetime-system/clock_sources"))
		(form-update-value "clocksources" (woo-get-option (woo-read-first "/datetime-system") 'clocksource_current))
    (clocksource-show)
	  (update-effect))))

(define (init)
  ;; effects
  (effect-disable "ntp_pool" "ntp_status" #f)
  (effect-disable "ntp_accept" "ntp_status" #f)
  (effect-disable "date" "ntp_status" #t)
  (effect-disable "time" "ntp_status" #t)
  (init-effect)
  ;; form
  (ui-read)
  ;; events
  (form-bind "apply" "click" ui-write)
  (form-bind "reset" "click" ui-read)
  (form-bind "change-zone" "click" ui-timezone)
  (form-bind-timeedit "time" ui-timeedit))
