(document:surround "/std/frame")

(define (ui-write)
  (catch/message
    (lambda()
	(apply woo-write "/datetime-system" (form-value-list))
	(ui-read))))

(define (ui-read)
  (catch/message
	(lambda()
	  (let ((cmd  (woo-read-first "/datetime-system" 'language (form-value "language"))))
		(form-update-value-list
		  '("date" "time" "ntp_status" "ntp_pool" "ntp_accept" "utc" "timezone")
		  cmd)
		(form-update-activity "ntp_status" (woo-get-option cmd 'ntp_installed))
    (form-update-enum "clocksources" (woo-list "/datetime-system/clock_sources"))
    (form-update-value "clocksources" (woo-get-option (woo-read-first "/datetime-system") 'clocksource_current))
    ))))

(define (ui-timezone)
  (form-popup "/datetime/system/timezone")
  (ui-read))

(define (clocksource-show)
  (form-update-visibility "clocksource_hbox" 
    (and 
      (eq? 1 (form-cookie "expert_mode"))
      (woo-get-option (woo-read-first "/datetime-system") 'clocksource_show)
    )
  )
)

(gridbox columns "50;50"
       margin 20
       (gridbox
         columns "50;50"
         colspan 2
         align "left"
         (checkbox text (_ "Get time from NTP server:") name "ntp_status")
         (hbox (label name "ntp_pool" text (_ "NTP server:") visibility #f)
               (edit name "ntp_pool")))

       (checkbox text (_ "Work as NTP server") widget-name "ntp_accept" name "ntp_accept")
       (spacer)

       (separator colspan 2)

       (label text (_ "Current date:") align "center" name "date")
       (label text (_ "Current time:") align "center" name "time")

       (dateedit expanded #t name "date")
       (timeedit expanded #t name "time")

       (label colspan 2)

       (checkbox name "utc" text (_ "Hardware time set to GMT"))
       (spacer)

       (hbox
         align "left"
         (label text (_ "Time zone:"))
         (label text " ")
         (label name "timezone")
         (label text " ")
         (button name "change-zone" text (_ "Change...")))
       (spacer)

       (label colspan 2)

       (hbox name "clocksource_hbox" visibility #f
       (label text (_ "Select clock source: "))
       (combobox name "clocksources"))
       (spacer)

       (button name "apply" text (_ "Apply") align "left")
       (spacer))

(effect-disable "ntp_pool" "ntp_status" #f)
(effect-disable "ntp_accept" "ntp_status" #f)
(effect-disable "date" "ntp_status" #t)
(effect-disable "time" "ntp_status" #t)

(document:root
  (when loaded
    (ui-read)
    (clocksource-show)
    (form-bind "apply" "click" ui-write)
    (form-bind "change-zone" "click" ui-timezone)
    (form-bind "document:expert_mode" "change" clocksource-show)
    (init-effect)))
